//! `SeaORM` Entity. Generated by sea-orm-codegen 0.12.15

use sea_orm::entity::prelude::*;
use serde::{Deserialize, Serialize};

#[derive(Copy, Clone, Default, Debug, DeriveEntity)]
pub struct Entity;

impl EntityName for Entity {
    fn table_name(&self) -> &str {
        "license"
    }
}

#[derive(Clone, Debug, PartialEq, DeriveModel, DeriveActiveModel, Eq, Serialize, Deserialize)]
pub struct Model {
    #[serde(skip_deserializing)]
    pub id: Uuid,
    pub name: String,
    pub start: Option<DateTimeWithTimeZone>,
    pub end: Option<DateTimeWithTimeZone>,
    pub amount: Option<i32>,
    pub key: String,
    pub note: Option<String>,
    pub group_id: Uuid,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveColumn)]
pub enum Column {
    Id,
    Name,
    Start,
    End,
    Amount,
    Key,
    Note,
    GroupId,
}

#[derive(Copy, Clone, Debug, EnumIter, DerivePrimaryKey)]
pub enum PrimaryKey {
    Id,
}

impl PrimaryKeyTrait for PrimaryKey {
    type ValueType = Uuid;
    fn auto_increment() -> bool {
        false
    }
}

#[derive(Copy, Clone, Debug, EnumIter)]
pub enum Relation {
    LicenseGroup,
}

impl ColumnTrait for Column {
    type EntityName = Entity;
    fn def(&self) -> ColumnDef {
        match self {
            Self::Id => ColumnType::Uuid.def(),
            Self::Name => ColumnType::String(None).def(),
            Self::Start => ColumnType::TimestampWithTimeZone.def().null(),
            Self::End => ColumnType::TimestampWithTimeZone.def().null(),
            Self::Amount => ColumnType::Integer.def().null(),
            Self::Key => ColumnType::String(None).def(),
            Self::Note => ColumnType::String(None).def().null(),
            Self::GroupId => ColumnType::Uuid.def(),
        }
    }
}

impl RelationTrait for Relation {
    fn def(&self) -> RelationDef {
        match self {
            Self::LicenseGroup => Entity::belongs_to(super::license_group::Entity)
                .from(Column::GroupId)
                .to(super::license_group::Column::Id)
                .into(),
        }
    }
}

impl Related<super::license_group::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::LicenseGroup.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
